var gui = window.require("nw.gui");
var fs = require("fs");
var csv = require("csv");
var ComScriptReader = window.require("./app/comscript_reader");
var ComScriptWriter = window.require("./app/comscript_writer");
var Panel = window.require("./app/panel");
var Field = window.require("./app/field");

function ComScriptIO(config) {
  if(config["mode"] == "write")
    this.form = new ComScriptWriter(config, this);
  else
    this.form = new ComScriptReader(config, this);

  this.refreshEnabled = true;
  this.config = config;
  this.configureWindow();
  this.configureTabs();
  this.configureFields();
  this.refreshValues();
};

ComScriptIO.prototype.configureWindow = function() {
  //gui.Window.get().resizeTo(
  //  this.config["window"]["width"],
  //  this.config["window"]["height"]
  //);

  $("html").css("font-size", this.config["window"]["font-scaling"] + "%");
  $("title").text(this.config["title"]);

  if(this.config["window"]["background-color"])
    $("body").css("background-color", this.config["window"]["background-color"]);
};

ComScriptIO.prototype.configureTabs = function() {
  this.panels = {};
  var panels = this.panels;
  $.each(this.config["tabs"], function(index, tab) {
    var panel = new Panel(tab);
    panels[tab["key"]] = panel;
  });

  $("#tabs a").first().trigger("click");
};

ComScriptIO.prototype.configureFields = function() {
  this.fields = [];
  var form = this.form;
  var panels = this.panels;
  var fields = this.fields;

  this.config["fields"].forEach(function(config, index) {
    var field = new Field(config);
    fields.push(field);
    panels[config["tab"]].addField(field);
    form.configureField(field);
  });
}

ComScriptIO.prototype.refreshValues = function(initial) {
  if(!this.refreshEnabled) return;

  initial == initial || false;
  var config = this.config;
  var form = this.form;
  var fields = this.fields;

  var parser = csv.parse({ delimiter: ',' }, function(err, data){
    // remove the first element (tab name) from each row
    data = data.map(function(row) {
      row.shift();
      return row;
    });

    // flatten the array of values
    var values = [].concat.apply([],data);

    fields.forEach(function(field, index) {
      form.refreshField(field, values[index]);
    });
  });

  var stream = fs.createReadStream(config["file"]);
  stream.on('close', function(){ form.afterRefresh(); });
  stream.pipe(parser);
}

module.exports = ComScriptIO;
