global.$ = $

var fs   = require("fs");
var yaml = require("js-yaml");
var gui  = require("nw.gui");
var path = require("path");
var argv = require("minimist")(gui.App.argv);
var ComScriptIO = require("./app/comscript_io");

// Set the working directory if specified by the -d argument
if(argv["d"]) {
  process.chdir(argv["d"]);
}

$(document).ready(function(){
  $(".show-file-dialog").click(function() {
    $("#config-file").trigger("click");
  });

  $("#config-file").change(function() {
    var file = $(this).val();
    var dir = path.dirname(file);
    process.chdir(dir);
    config = yaml.safeLoad(fs.readFileSync(file));
    new ComScriptIO(config);
    $("#file-dialog").hide();
    $("#app").show();
  });
});

$(document).on('change', '.file-browser', function() {
	$(this).prev().val($(this).val());
});

onload = function() {
  try {
    if(argv["_"].length > 0) {
      config = yaml.safeLoad(fs.readFileSync(argv["_"][0]));
      new ComScriptIO(config);
      $("#app").show();
    } else {
      $("#file-dialog").show();
    }
    gui.Window.get().show();
  } catch(e) {
    process.stdout.write(e.toString());
    process.exit();
  }
}
