Panel = function(config) {
  this.title = config["title"];
  this.config = config;
  this.fields = [];

  var tabId = "tab-" + config["key"];

  $("#tabs").prepend(
    "<li><a data-toggle='tab' href='#" + tabId + "'>" +
      config['title'] + "</a></li>"
  );

  $("#tab-container").prepend(
    "<div id='" + tabId+ "' class='tab-pane fade'></div>"
  );
  this.element = $("#" + tabId);

  var table = $("#templates .field-table").clone();
  this.element.append(table);
  this.table = this.element.find(".field-table tbody");
};

Panel.prototype.addField = function(field) {
  this.fields.push(field);

  if(field.header !== undefined) {
    this.table.append(field.header);
  }

  this.table.append(field.row);
};

Panel.prototype.getFieldValues = function() {
  return $.map(this.fields, function(field, idx) {
    if(field.config["type"] == "checkbox") {
      if(field.element.prop('checked')) {
        return field.config["on_value"];
      } else {
        return field.config["off_value"];
      }
    } else {
      return field.element.val();
    }
  });
};

module.exports = Panel;
