var attributes = {
  'emailaccount' : {
    'address' : {
      'default' : 'test@test.com',
      'description' : 'The email address for this account'
    },
    'server' : {
      'default' : 'smtp.gmail.com',
      'description' : 'The server address'
    },
    'password' : {
      'default' : '',
      'description' : 'The password for this email account'
    },
    'ssl' : {
      'default' : '',
      'description' : 'True to use SSL when connecting to the server (required for gmail accounts)'
    }
  },
  'set' : {
    'var' : {
      'default' : '',
      'description' : 'The name of the variable to set'
    },
    'value' : {
      'default' : '',
      'description' : 'The new value of the variable'
    }
  },
  'savevars' : {
    'file' : {
      'default' : '',
      'description' : 'file to which variables are saved'
    },
    'value' : {
      'default' : '',
      'description' : 'The new value of the variable'
    }
  },

  'set' : {
    'var' : {
      'default' : '',
      'description' : 'The name of the variable to set'
    },
    'value' : {
      'default' : '',
      'description' : 'The new value of the variable'
    }
  },

  'device' : {
    'name' : {
      'default' : '',
      'description' : 'A string used to refer to the device in the profile'
    },
    'type' : {
      'default' : '',
      'description' : 'Serial" or "tcp" depending on the type of connection'
    },
    'port' : {
      'default' : '',
      'description' : ' a local port to which the device is connected'
    },
    'baudrate' : {
      'default' : '',
      'description' : 'the baud rate for the connection'
    },
    'parity' : {
      'default' : '',
      'description' : 'the value of the parity for the connection (Even, Odd, None, Mark, or Space)'
    },
    'stopbits' : {
      'default' : '',
      'description' : 'the integer value for the stop bits for the connection'
    },
    'databits' : {
      'default' : '',
      'description' : 'the integer value for the data bits for the connection'
    },
    'handshake' : {
      'default' : '',
      'description' : 'None, XOnXOff, RequestToSend, RequestToSendXOnXOff'
    },
    'dtr' : {
      'default' : '',
      'description' : 'True, False'
    },
    'ip' : {
      'default' : '',
      'description' : 'The ip address of the device'
    },
    'dns' : {
      'default' : '',
      'description' : 'The url of the device'
    }
  },
  'setdevice' : {
    'name' : {
      'default' : '',
      'description' : 'The name of the device to set'
    }
  },

  'import' : {
    'file' : {
      'default' : 'scripts/MySubScripts.xml',
      'description' : 'The path and file name of the XML file containing the external script'

    }
  },

  'profile' : {
    'start' : {
      'default' : '',
      'description' : 'the time at which execution should begin (dd/mm/yyyy hh:mm:ss)'
    },
    'end' : {
      'default' : '',
      'description' : 'the time at which execution should stop (dd/mm/yyyy hh:mm:ss)'
    },
    'interval' : {
      'default' : '',
      'description' : 'the number of seconds between profile iterations'
    },
    'consoleoutput' : {
      'default' : '',
      'description' : 'True to output logs to the console window, False to hide them'
    },
    'debug' : {
      'default' : '',
      'description' : 'True to enable debug messages, False to hide them'
    },
    'logfile' : {
      'default' : '',
      'description' : 'True to log command output, False to hide it'
    },
    'failscript' : {
      'default' : '',
      'description' : 'the name of the script to run if the profile fails'
    },
    'dateformat' : {
      'default' : '',
      'description' : 'the MS date format to use for logging messages. The default is "MM/dd/yyyy HH/mm/ss".'
    }
  },

  'script' : {
    'name' : {
      'default' : 'main',
      'description' : 'A unique string (name) to identify the script'
    }
  },
  'run' : {
    'script' : {
      'default' : '',
      'description' : 'The script to run'
    },
    'file' : {
      'default' : '',
      'description' : 'The file to run'
    },
    'args' : {
      'default' : '',
      'description' : 'comma separated list of parameters used by the called program'
    },
    'background' : {
      'default' : '',
      'description' : 'True to start the process'
    }
  },

  'canconnect' : {
    'var' : {
      'default' : '',
      'description' : 'the variable to store the result in'
    },
    'device' : {
      'default' : '',
      'description' : 'the name of the device'
    }
  },

  'closeport' : {
    'device' : {
      'default' : '',
      'description' : 'the name of the serial device'
    }
  },

  'collect' : {
    'file' : {
      'default' : '',
      'description' : 'The filename to write all collected data to'
    },
    'var' : {
      'default' : '',
      'description' : 'the variable to write all collected data to'
    },
    'type' : {
      'default' : '',
      'description' : '"Hex" or "Text" depending on the type of communication'
    },
    'behavior' : {
      'default' : '',
      'description' : ':"triggerterminator" (can be abrievieated "tt"), "chars", or "numberofbytes'
    },
    'timeout' : {
      'default' : '',
      'description' : 'the max milliseconds to wait for the terminator before ending communication with the device'
    },
    'aftercollection' : {
      'default' : '',
      'description' : 'a string to be appended to the collected data'
    },
    'ms' : {
      'default' : '',
      'description' : 'integer value for the minimum milliseconds to wait after collection begins - trigger characters or strings are ignored during this period.'
    },
    'trigger' : {
      'default' : '',
      'description' : 'the string to wait for before collecting/looking for the terminator. Empty string to begin collecting immediately.'
    },
    'terminator' : {
      'default' : '',
      'description' : 'the string to wait for before terminating the connection. Empty string to collect until the timeout occurs.'
    },
    'keeptrigger' : {
      'default' : '',
      'description' : '"True" or "False" - determines if the trigger is also collected along with the data following it'
    },
    'keepterminator' : {
      'default' : '',
      'description' : '"True" or "False" - determines if the terminator is also collected along with the data preceding it'
    },
    'length' : {
      'default' : '',
      'description' : 'the number of characters to collect'
    },
    'collected' : {
      'default' : '',
      'description' : 'the name of the variable to store the number of collected characters'
    },
    'bytes' : {
      'default' : '',
      'description' : 'number of bytes to collect'
    },
    'bytescollected' : {
      'default' : '',
      'description' : 'number of bytes actually collected'
    },
    'var' : {
      'default' : '',
      'description' : 'the name of the variable to store the collected bytes'
    }
  },

  'send' : {
    'file' : {
      'default' : '',
      'description' : 'The filename to write all collected data to'
    },
    'var' : {
      'default' : '',
      'description' : 'the variable to write all collected data to'
    },
    'type' : {
      'default' : '',
      'description' : '"Hex" or "Text" depending on the type of communication'
    },
    'behavior' : {
      'default' : '',
      'description' : ':"triggerterminator" (can be abrievieated "tt"), "chars", or "numberofbytes'
    },
    'timeout' : {
      'default' : '',
      'description' : 'the max milliseconds to wait for the terminator before ending communication with the device'
    },
    'aftercollection' : {
      'default' : '',
      'description' : 'a string to be appended to the collected data'
    },
    'ms' : {
      'default' : '',
      'description' : 'integer value for the minimum milliseconds to wait after collection begins - terminating characters or strings are ignored during this period.'
    },
    'trigger' : {
      'default' : '',
      'description' : 'the string to wait for before collecting/looking for the terminator. Empty string to begin collecting immediately.'
    },
    'terminator' : {
      'default' : '',
      'description' : 'the string to wait for before terminating the connection. Empty string to collect until the timeout occurs.'
    },
    'keeptrigger' : {
      'default' : '',
      'description' : '"True" or "False" - determines if the trigger is also collected along with the data following it'
    },
    'keepterminator' : {
      'default' : '',
      'description' : '"True" or "False" - determines if the terminator is also collected along with the data preceding it'
    },
    'length' : {
      'default' : '',
      'description' : 'the number of characters to collect'
    },
    'collected' : {
      'default' : '',
      'description' : 'the name of the variable to store the number of collected characters'
    },
    'bytes' : {
      'default' : '',
      'description' : 'number of bytes to collect'
    },
    'bytescollected' : {
      'default' : '',
      'description' : 'number of bytes actually collected'
    },
    'var' : {
      'default' : '',
      'description' : 'the name of the variable to store the collected bytes'
    },
    'sendfile' : {
      'default' : '',
      'description' : 'the file to be sent to the device'
    },
    'start' : {
      'default' : '',
      'description' : 'the line of the file to start from'
    },
    'sendlines' : {
      'default' : '',
      'description' : 'the number of lines to send'
    },
    'sendchars' : {
      'default' : '',
      'description' : 'the number of ASCII characters to send'
    }
  },

  'setdevice' : {
    'name' : {
      'default' : '',
      'description' : 'the name of a device previously declared in the profile'
    }
  },

  'loadvars' : {
    'string' : {
      'default' : '',
      'description' : 'the string of data to parse'
    },
    'delimiter' : {
      'default' : '',
      'description' : 'the character separating each value in the line'
    },
    'type' : {
      'default' : '',
      'description' : 'the source of the variables to load - "text" for textfiles, "string" for text strings and "xml" for the config.xml file'
    },
    'line' : {
      'default' : '',
      'description' : 'the integer value for the line of the file to parse (for text files only).  This attribute works well inside a while loop so ComScript parses a set number of lines from a file'
    },
    'vars' : {
      'default' : '',
      'description' : ' the list of one or more variables to save the data into separated by commas.  Not used with the config.xml file'
    },
    'multi' : {
      'default' : 'False',
      'description' : '"True" to treat multiple instances of the delimiter as a single instance, "False" by default.  Very useful with space formatted output.'
    },
    'file' : {
      'default' : '',
      'description' : 'the path of the xml or text file relative to the profile directory'
    },
    'chars' : {
      'default' : '',
      'description' : 'The number of ASCII characters to put into each variable when not using a delimiter'

    }
  },

  'sizeof' : {
    'var' : {
      'default' : '',
      'description' : 'the variable of which to compute the size'
    },
    'result' : {
      'default' : '',
      'description' : 'the variable in which to store the size'
    },
    'type' : {
      'default' : '',
      'description' : '"length" to compute string length, "bytes" to compute the number of bytes in a hex string'
    }

  },

  'typetest' : {
    'var' : {
      'default' : '',
      'description' : 'the variable to be tested'
    },
    'type' : {
      'default' : '',
      'description' : '"int", "double"'
    },
    'result' : {
      'default' : '',
      'description' : 'the variable to store the result in'
    }
  },

  'email' : {
    'to' : {
      'default' : '',
      'description' : 'the email address to send to'
    },
    'subject' : {
      'default' : '',
      'description' : 'The subject of the email'
    },
    'message' : {
      'default' : '',
      'description' : 'The body of the email message files: A comma-separated list of attachments wait: True to wait for the message to send before continuing execution (default is false) result: The name of the variable in which store the result (e.g "true" for successfully sent or "false" for unsuccessfully sent)'
    },
    'files' : {
      'default' : '',
      'description' : 'a comma separated list of files to attach'
    }
  },

  'sendfile' : {
    'localfile' : {
      'default' : '',
      'description' : 'the path and filename of the file to be sent'
    },
    'remotefile' : {
      'default' : '',
      'description' : 'the path and filename where the file should be placed on the serverl'
    },
    'username' : {
      'default' : '',
      'description' : 'the FTP username for the remote server'
    },
    'password' : {
      'default' : '',
      'description' : 'the FTP password for the remote server ip: the IP address of the remote server'
    },
    'hostname' : {
      'default' : '',
      'description' : 'the hostname of the remote server (note: either hostname or ip must be included)'
    },
    'sftp' : {
      'default' : '',
      'description' : 'True to use SFTP, False for regular FTP'
    },
    'ip' : {
      'default' : '',
      'description' : 'IP adress replaces hostname'
    }
  },

  'append' : {
    'file' : {
      'default' : '',
      'description' : 'the source filename'
    },
    'to' : {
      'default' : '',
      'description' : 'the destination filename'
    },
    'newline' : {
      'default' : 'False',
      'description' : 'True add a new line before appending the content (default is false)'
    }
  },

  'copy' : {
    'file' : {
      'default' : '',
      'description' : 'the path and filename'
    },
    'to' : {
      'default' : '',
      'description' : 'the path and new filename'
    },
    'replace' : {
      'default' : 'True',
      'description' : 'True to overwrite existing file, false to prevent overwriting (default is true)'
    }
  },

  'create' : {
    'file' : {
      'default' : '',
      'description' : 'the path and filename to be created'
    }
  },

  'createdir' : {
    'path' : {
      'default' : '',
      'description' : 'the path to be created'
    }
  },

  'delete' : {
    'file' : {
      'default' : '',
      'description' : 'the path and filename to be deleted'
    }
  },

  'deletedir' : {
    'path' : {
      'default' : '',
      'description' : 'the path to be deleted'
    }
  },

  'exists' : {
    'path' : {
      'default' : '',
      'description' : 'the directory or file to be checked'
    },
    'result' : {
      'default' : '',
      'description' : 'the variable in which the result is stored'
    }
  },

  'rename' : {
    'file' : {
      'default' : '',
      'description' : 'the path and filename'
    },
    'to' : {
      'default' : '',
      'description' : 'the new path and file name'
    },
    'replace' : {
      'default' : 'True',
      'description' : 'True to overwrite existing file, False to prevent overwriting (default is true)'
    }
  },

  'readfile' : {
    'file' : {
      'default' : '',
      'description' : 'the path and file to be opened.  Default path is in local profile directory.'
    },
    'var' : {
      'default' : '',
      'description' : 'the variable in which to store each line'
    },
    'skipempty' : {
      'default' : 'True',
      'description' : 'True to skip over empty lines, False to read them. (default is true)'
    }
  },

  'write' : {
    'string' : {
      'default' : '',
      'description' : 'the string to write to the file'
    },
    'file' : {
      'default' : '',
      'description' : 'the file path and name.  Default path is local  '
    }
  },
  'onfail' : {
  },
  'logfile' : {
  },

  'kill' : {
    'message' : {
      'default' : 'terminating profile',
      'description' : 'the message to be logged by this command. The default message is "terminating profile".'
    }
  },

  'log' : {
    'message' : {
      'default' : '',
      'description' : 'the message to be logged'
    }
  },

  'multitask' : {
    'timeout' : {
      'default' : '',
      'description' : 'ms to wait before terminating the the multitask'
    }
  },

  'parse' : {
    'hexvar' : {
      'default' : '',
      'description' : 'the name of the variable containing the hex string'
    },
    'vars' : {
      'default' : '',
      'description' : 'The comma-separated list of variable names'
    },
    'type' : {
      'default' : '',
      'description' : 'vars2hex to parse the variables into a hex variable, hex2vars to parse the hex variable into variables'
    }
  },

  'break' : {
  },

  'if/else' : {
    'condition' : {
      'default' : '',
      'description' : 'the condition to be evaluated (use LT, LTE, GT, GTE, ==, !=, AND, OR for comparisons). Use single quotes for string comparisons.  note: because ComScript uses greater than and less than symbols in the xml command structure, comparisonsare done as described above.'
    }
  },

  'switch' : {
    'var' : {
      'default' : '',
      'description' : 'The variable to compare all cases to'
    }
  },

  'while' : {
    'condition' : {
      'default' : '',
      'description' : 'the condition to be evaluated. The same conditonal expressions used in the if command also apply to while command.'
    }
  },

  'math' : {
    'var' : {
      'default' : '',
      'description' : 'the name of the variable to store the result'
    },
    'expression' : {
      'default' : '',
      'description' : 'the mathematical expression to be solved.'
    }
  },

  'Date' : {
    'var' : {
      'default' : '',
      'description' : 'the name of the variable'
    },
    'format' : {
      'default' : '',
      'description' : 'the Microsoft date format string'
    }
  },

  'elapsedtime' : {
    'var' : {
      'default' : '',
      'description' : 'The variable to store the elapsed time in'
    },
    'format' : {
      'default' : '',
      'description' : 'days, hours, minutes, ms, or seconds'
    },
    'resett' : {
      'default' : '',
      'description' : '"True" to reset the timer'
    }
  },

  'pause' : {
    'seconds' : {
      'default' : '',
      'description' : 'the integer value for the number of seconds to pause'
    },
    'ms' : {
      'default' : '',
      'description' : ' the integer value for the number of milliseconds to pause'
    }
  },

  'set' : {
    'var' : {
      'default' : '',
      'description' : 'the name of the variable'
    },
    'vars' : {
      'default' : '',
      'description' : 'the name of the variables'
    },
    'value' : {
      'default' : '',
      'description' : ' the values for the variable.  If setting multiple variables, the list or vars and values are comma separated and are matched in order.'
    },
    'values' : {
      'default' : '',
      'description' : ' the values for the variables.  If setting multiple variables, the list or vars and values are comma separated and are matched in order.'

    }
  },
  
  'var' : {
    'name' : {
      'default' : 'DIvar',
      'description' : 'variable name(case specific)'
    },
    'value' : {
      'default' : '',
      'description' : 'initial value, can be null with ""'
    },
    'editable' : {
      'default' : '',
      'description' : 'True so user can edit, False for view only'
    },
    'visible' : {
      'default' : 'True',
      'description' : 'True or False to appear in DI'
    },
    'label' : {
      'default' : '',
      'description' : 'units or other identifying label'
    },
    'final' : {
      'default' : 'False',
      'description' : 'True to prevent profile from resetting the variable'
    },
    'inputtype' : {
      'default' : 'textbox',
      'description' : 'textbox or checkbox(checked=1, unchecked=0)'
    }

  }

}
