var commands = {
  'Startup Script Commands' : {
    'Import a script file' : '<import file="/subscripts/SubScripts.xml" />',
    'Load config file Data Interface' : '<loadvars file="config.xml" type="xml" />',
    'Configure email account' : '<emailaccount address="from email address here" server="server address here" password="" default="true" ssl="false" />',
    'Add a serial device' : '<device name="MySerialDevice" type="serial" port="COM1" baudrate="9600" parity="Even" stopbits="1" databits="8" handshake="None" dtr="False" />',
    'Add a TCP device by IP' : '<device name="MyTCPDevice" type="tcp" port="40" ip="192.168.1.101" />',
    'Add a TCP device by DNS' : '<device name="MyTCPDevice" type="tcp" port="12345" dns="my.device.com" />'
  },

  'Profile Setup' : {
    'Add subscript template' : '\n<script name="MySubScript">\n <!--*** add commands inside script tags ***-->\n</script>\n',
    'Stop profile execution' : '<kill message="Profile ended!" />'
  },
  
  'Data Interface Config file ONLY' : {
    'Add a user editable variable' : '<var name="UserVar" value="" visible="True" editable="True" final="False" label="" />',
    'Add a non user editable - variable' : '<var name="DisplayVar" value="" visible="True" editable="False" final="False" label="" />'
  },

  'Device Setup/Communication' : {
    'Add a serial device' : '<device name="MySerialDevice" type="serial" port="COM1" baudrate="9600" parity="Even" stopbits="1" databits="8" handshake="None" dtr="False" />',
    'Add a TCP device by IP' : '<device name="MyTCPDevice" type="tcp" port="40" ip="192.168.1.101" />',
    'Add a TCP device by DNS' : '<device name="MyTCPDevice" type="tcp" port="12345" dns="my.device.com" />',
    'Set the current device for - comms' : '<setdevice name="MyDevice" />',
    'Check device connection' : '<canconnect device="MyDevice" var="ConnectResultVar" />',
    'Close device connection' : '<closeport device="MyDevice" />',
    'Collect data with a - trigger/terminator' : '<collect behavior="tt" var="DataVar" trigger="" terminator="" keeptrigger="true" keepterminator="false" ms="0" timeout="5000" file="CollectFile.txt" />',
    'Collect a number of characters' : '<collect behavior="chars" length="8" ms="0" timeout="5000" var="DataVar" file="CollectFile.txt" collected="ActualNumCollected" type="text" />',
    'Collect a number of binary - bytes' : '<collect behavior="numberofbytes" numbytes="4" var="BinaryDataVar" file="CollectFile.txt" type="Hex" ms="0" timeout="5000" bytescollected="ActucNumCollected" />',
    'Send a string to a device' : '<send string="hello" />'
  },

  'Conditionals / Loops' : {
    'Simple If' : '<if condition="[x] LT 10">\n<!-- Any commands placed inside the if tags will execute if the condition is true. -->\n\n</if>',
    'If with an And condition' : '<if condition="([x] LT 10) AND ([y] GTE 10) ">\n<!-- Any commands placed inside the if tags will execute if both conditions are true. -->\n\n</if>',
    'If/Else' : '<if condition="[x] LT 10">\n<!-- Any commands placed inside the if tags will execute if the condition is true. -->\n<else>\n\n<!-- Any commands placed inside the else tags will execute if the condition is false. -->\n\n</else>\n</if>',
    'While loop' : '<while condition="[i] LT 10" >\n<!-- Any commands placed inside the while tags will execute until the condition is false. -->\n</while>',
    'While loop with an Or condition' : '<while condition="([i] LT 10) OR ([y] GTE 10)" >\n<!-- Any commands inside the while tags will execute both condition are false. -->\n\n</while>',
    'Break/Exit out of loop' : '<break /><!-- Exit the loop -->',
    'Switch statement' : '<switch var="x">\n<case value="1">\n<!-- Any commands placed inside these case tags will execute if x = 1. -->\n\n</case>\n<case value="2">\n<!-- Any commands placed inside these case tags will execute if x = 2. -->\n\n</case>\n<default>\n\n<!-- Any commands placed inside the default tags will execute if none of the above cases match. -->\n\n</default>\n</switch>'
  },

  'Date, Time and Timing' : {
    'Get the current PC date time' : '<date var="PC-DateTime" format="MM/dd/yyyy hh:mm:ss" />',
    'Get the current PC date' : '<date var="PC-Date" format="MM/dd/yyyy" />',
    'Get the current PC time' : '<date var="PC-Time" format="hh:mm:ss" />',
    'Pause the profile(seconds)' : '<pause seconds="5" />',
    'Pause the profile(milli-seconds)' : '<pause ms="250" />',
    'Get the elapsed time' : '<elapsedtime var="ET" format="seconds" reset="false" />',
    'Reset the elapsed time' : '<elapsedtime var="ET" format="seconds" reset="true" />'
  },

  'Email/FTP' : {
    'Send an email' : '<email to="recipient email here" subject="" message="" files="file(s) to attach" wait="true" result="" onfail="true" />',
    'Send a file via FTP' : '<sendfile localfile="local name and relative path " remotefile="name and path on server" username="" password="" hostname="server hostname" wait="true" onfail="true"/>',
    'Send a file via SFTP' : '<sendfile localfile="local name and relative path" remotefile="name and path on server" username="" password="" hostname="server hostname" wait="true" sftp="true" onfail="true"/>'
  },

  'Files Operations and Directories' : {
    'Import a file' : '<import file="scripts/MySubScripts.xml" />',
    'Write a string to a file' : '<write file="myFile.txt" string="Hello, World!" />',
    'Append one file to another' : '<append file="source.txt" to="destination.txt" newline="false" />',
    'Copy a file' : '<copy file="source.txt" to="destination.txt" replace="true" />',
    'Create a file' : '<create file="myFile.txt" />',
    'Create a directory' : '<createdir path="path/to/directory" />',
    'Delete a file' : '<delete file="myFile.txt" />',
    'Delete a directory' : '<deletedir path="path/to/directory" />',
    'Determine if a path exists' : '<exists path="path/to/file.txt" result="fileExists" />',
    'Rename a file' : '<rename file="file1.txt" to="file2.txt" replace="true" />'
  },

  'General' : {
    'Set a variable' : '<set var="x" value="1" />',
    'Set multiple variables' : '<set vars="x,y,z" values="1,2,3" />',
    'Log a message' : '<log message="The value of var x is [x]" />',
    'Stop profile execution' : '<kill message="Done!" />',
    'Import a script file' : '<import file="myScripts.xml" />',
    'Run a script' : '<run script="myScript" />',
    'Run an external file' : '<run file="RunStats.bat" args="StatScriptFile" background="true" />',
    'Start a thread' : '<multitask timeout="0">\n<!-- Any commands placed here will run simultaneously with the profile. -->\n</multitask>',
    'Disable console output'  : '<set consoleoutput="false" />',
    'Enable console output'  : '<set consoleoutput="true" />',
    'Disable debug messages'   : '<set debug="false" />',
    'Enable debug messages'   : '<set debug="true" />',
    'Disable file logging'    : '<set logfile="false" />',
    'Enable file logging'    : '<set logfile="true" />',
    'Continue through command - failure' : '<set onfail="true" />',
    'Stop profile execution on - command failure' : '<set onfail="false" />',
    'Add a comment' : '<!--COMMENT:      -->'
  },

  'Hex and Decimal Conversions' : {
    'Convert decimal var(s) to hex' : '<parse type="vars2hex" hexvar="HexVar1,HexVar2" vars="x,y" /> <!-- note: no [] around vars, they are already designated variables -->',
    'Convert a hex sting into - decimal vars' : '<parse type="hex2vars" hexvar="MyHexString" vars="0xNum1,0xNum2,0xNum3" /> <!-- note: no [] around vars, they are already designated variables -->'
  },
  'Math' : {
    'Arithmatic expression' : '<math var="x2" expression="[x]+10" />',
    'Multiplication expression' : '<math var="x" expression="5.555 * 11" />',
    'Exponential expression' : '<math var="result" expression="Pow(([x]*[y]),2)" />',
    'Trigonometric expression' : '<math var="result" expression="Sin([x]*[PI]/180)" />',
    'Increment a loop counter' : '<math var="LoopCounter" expression="[LoopCounter]+1" />'
  },
  'Variables/Parsing Files' : {
    'Set a variable' : '<set var="x" value="1" />',
    'Set multiple variables' : '<set vars="x,y,z" values="1,2,3" />',
    'Load vars from text file' : '<loadvars file="MyInputFile.txt" type="text" line="1" delimiter="," vars="a,b,c" multi="false" />',
    'Parse/Load vars from string' : '<loadvars type="string" string="" delimiter=" " vars="" multi="true" />',
    'Load a number of chars into - vars from a string' : '<loadvars type="string" string="" vars="" chars="" /> <!-- loads 2 chars into each variable -->',
    'Load vars from an XML file' : '<loadvars type="xml" file="vars.xml" />',
    'Read all lines of a file into - a string var' : '<readfile file="myfile.txt" var="DataLine" skipempty="true">\n<!-- Any commands placed between the readfile tags can operate on each instance of [DataLine](e.g. parse into vars). -->\n\n</readfile>',
    'Save all variables to a file' : '<savevars file="vars.xml" />'
  },
  'Variable Testing' : {
    'Get the length of a string' : '<sizeof var="MyString" result="sizeOfMyString" type="length" /> <!-- no [] for var - already designated a variable-->',
    'Get the byte count of a string' : '<sizeof var="x" result="sizeOfX" type="bytes" /> <!-- no [] for var - already designated a variable-->',
    'Check if a variable is an integer' : '<typetest var="x" type="int" result="test" /> <!-- no [] for var - already designated a variable-->',
    'Check if a variable is a float' : '<typetest var="x" type="double" result="test" /> <!-- no [] for var - already designated a variable-->'
  }
}
